{*********************************************************}
{                                                         }
{    RIPC                                                 }
{    Login Form                                           }
{                                                         }
{    Copyright (c) 2005 Volodimir V. Flyonts              }
{    Send all comments to e-mail: flyonts@ukr.net         }
{                                                         }
{    Version 1.1 Beta                                     }
{                                                         }
{*********************************************************}

{

Copyright (C) 2005 Vladimir V. Flyonts

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA.

Please send remarks, questions and bug reports to flyonts@ukr.net

}

unit LoginForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, IniFiles;

type
  TfrmLogin = class(TForm)
    Image1: TImage;
    edtUserName: TEdit;
    edtPassword: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    edtNewPwd: TEdit;
    edtConfirm: TEdit;
    btnOk: TButton;
    btnCancel: TButton;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  function Login(var UserName, Password: string): Boolean;
  function ChangePassword(var UserName, Password,
    NewPassword, Confirm: string): Boolean;

var
  frmLogin: TfrmLogin;

implementation

{$R *.dfm}

function Login(var UserName, Password: string): Boolean;
begin
  with TfrmLogin.Create(Application) do
  try
    Label3.Hide;
    Label4.Hide;
    edtNewPwd.Hide;
    edtConfirm.Hide;
    Height := 200;
    edtUserName.Text := UserName;
    edtPassword.Text := Password;
    Result := ShowModal = mrOk;
    if Result then
    begin
      UserName := edtUserName.Text;
      Password := edtPassword.Text;
    end;
  finally
    Free;
  end;
end;

function ChangePassword(var UserName, Password,
  NewPassword, Confirm: string): Boolean;
begin
  with TfrmLogin.Create(Application) do
  try
    edtUserName.Text := UserName;
    edtPassword.Text := Password;
    edtNewPwd.Text := NewPassword;
    edtConfirm.Text := Confirm;
    Result := ShowModal = mrOk;
    if Result then
    begin
      UserName := edtUserName.Text;
      Password := edtPassword.Text;
      NewPassword := edtNewPwd.Text;
      Confirm := edtConfirm.Text;
    end;
  finally
    Free;
  end;
end;

procedure TfrmLogin.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = 27 then btnCancel.Click;
end;

end.
