{*********************************************************}
{                                                         }
{    RIPC                                                 }
{    Comp. Reg. Info Form Unit                            }
{                                                         }
{    Copyright (c) 2005 Volodimir V. Flyonts              }
{    Send all comments to e-mail: flyonts@ukr.net         }
{                                                         }
{    Version 1.1 Beta                                     }
{                                                         }
{*********************************************************}

{

Copyright (C) 2005 Vladimir V. Flyonts

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA.

Please send remarks, questions and bug reports to flyonts@ukr.net

}

unit PcConfigForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TfrmPcConfig = class(TForm)
    btnCancel: TButton;
    btnOk: TButton;
    btnRestore: TButton;
    edtSvcPwd: TEdit;
    edtPcName: TEdit;
    edtPort: TEdit;
    Image1: TImage;
    PageControl1: TPageControl;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    TabSheet1: TTabSheet;
    procedure edtPortChange(Sender: TObject);
    procedure btnRestoreClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    PortNumber: Integer;
    { Public declarations }
  end;

var
  frmPcConfig: TfrmPcConfig;

function PcConfig(var APcName: string; var ASvcPwd: string; var APort: Word): Boolean;

implementation

{$R *.dfm}

uses
  RipSvc;

resourcestring
  SInvalidPortNumber = '"%s" is not a valid port number';

function PcConfig(var APcName: string; var ASvcPwd: string; var APort: Word): Boolean;
const
  StrongPassword = '****************';
begin
  with TfrmPcConfig.Create(Application) do
  try
    edtPcName.Text := APcName;
    if CompareStr(ASvcPwd, '') <> 0 then
      edtSvcPwd.Text := StrongPassword
    else
      edtSvcPwd.Text := '';
    edtPort.Text := IntToStr(APort);
    edtPort.OnChange(edtPort);

    Result := ShowModal = mrOk;
    
    if Result then
    begin
      APcName := edtPcName.Text;
      if CompareStr(edtSvcPwd.Text, StrongPassword) <> 0 then
        ASvcPwd := edtSvcPwd.Text;
      APort := Word(PortNumber);
    end;
  finally
    Free;
  end;
end;

procedure TfrmPcConfig.edtPortChange(Sender: TObject);
var
  APort, ACode: Integer;
begin
  Val(edtPort.Text, APort, ACode);
  if (ACode > 0) or (APort < 0) or (APort > MaxWord) then
  begin
    MessageBox(Handle, PChar(Format(SInvalidPortNumber, [edtPort.Text])),
      PChar(Caption), MB_ICONWARNING + MB_OK);
    edtPort.Text := IntToStr(PortNumber);
  end else
    PortNumber := APort;
end;
  
procedure TfrmPcConfig.btnRestoreClick(Sender: TObject);
begin
  edtPort.Text := IntToStr(RipDefPort);
  edtPortChange(edtPort);
end;

procedure TfrmPcConfig.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = 27 then
    btnCancel.Click;
end;

end.
