{*********************************************************}
{                                                         }
{    RIPC                                                 }
{    Simple Terminal Console                              }
{                                                         }
{    Copyright (c) 2005 Volodimir V. Flyonts              }
{    Send all comments to e-mail: flyonts@ukr.net         }
{                                                         }
{    Version 1.1 Beta                                     }
{                                                         }
{*********************************************************}

{

Copyright (C) 2005 Vladimir V. Flyonts

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA  02111-1307, USA.

Please send remarks, questions and bug reports to flyonts@ukr.net

}

program ripcterm;

{$APPTYPE CONSOLE}

uses
  Windows, SysUtils, WinSock;

const
  PETE = 'Press Enter to Exit...';

var
  Host: string;
  Port: Word;
  Data: WSAData;
  HostEnt: PHostEnt;
  HostIP: Cardinal;
  Sock: TSocket;
  SockAddr: TSockAddr;
  ErrorCode: Integer;
  ExitFlag: Boolean;
  Buffer: array[0..8190]of Char;
  BufLen: Cardinal;
  BufStr: string;
  CmdStr: string;
  
begin
  WriteLn('Simple RIPC/1.1 Terminal');
  Write('Enter address of host: '); ReadLn(Host);
  Write('Enter port (def:1984): '); ReadLn(Port);

  WSAStartup(2, Data);
  Sock := socket(AF_INET, SOCK_STREAM, IPPROTO_IP);

  if Sock = INVALID_SOCKET then
  begin
    WriteLn('Error: Can not create socket, WSAError ', WSAGetLastError);
    Write(PETE); ReadLn;
    Exit;
  end else
    WriteLn('Socket created.');

  WriteLn('Attempting connection to ', Host,' ...');

  HostEnt := gethostbyname(PChar(Host));
  if HostEnt = nil then
  begin
    HostIP := inet_addr(PChar(Host));
    HostEnt := gethostbyaddr(@HostIP, SizeOf(HostIP), 0);
    if HostEnt = nil then
    begin
      WriteLn('Error: Could not find host.');
      Write(PETE); ReadLn;
      Exit;
    end;
  end;

  with SockAddr do
  begin
    sin_addr := PInAddr(HostEnt^.h_addr^)^;
    sin_family := HostEnt^.h_addrtype;
    sin_port := htons(Port);
  end;

  ErrorCode := connect(Sock, SockAddr, SizeOf(SockAddr));
  if ErrorCode <> NO_ERROR then
  begin
    WriteLn('Error: Can not connect to socket, WSAError ', WSAGetLastError);
    Write(PETE); ReadLn;
    Exit;
  end else
    WriteLn('Socket connected.');

  ExitFlag := False;
  repeat
    FillChar(Buffer, SizeOf(Buffer), 0);

    // read ansver and skip binary data (header = 0)
    BufLen := SizeOf(Buffer);
    while (BufLen > 0) and (PCardinal(@Buffer)^ = 0) do
      BufLen := recv(Sock, Buffer, SizeOf(Buffer), 0);

    if BufLen > 0 then
    begin
      // 221-Service closing control connection
      ExitFlag := (PCardinal(@Buffer)^ and $00ffffff) = $00313232;

      SetString(BufStr, Buffer, BufLen);
      WriteLn(BufStr);
    end;

    if ExitFlag then Break;

    Write('] ');
    ReadLn(CmdStr);

    ErrorCode := send(Sock, Pointer(CmdStr)^, Length(CmdStr), 0);
    if ErrorCode = SOCKET_ERROR then
    begin
      WriteLn('Error: Can not send string, WSAError ', WSAGetLastError);
      Break;
    end;
    
  until ExitFlag;

  Write(PETE); ReadLn;
end.

